#!/usr/bin/perl -w

use strict;
use Gtk2 '-init';
# Variables convencionals true i false
use Glib qw(TRUE FALSE);

use lib ("/home/Rasta/Documents/Universitat/Projecte Final de Carrera/Xat");
use clientX;
use serverX;

use threads;
use threads::shared;

#== VARIABLES GLOBALS ==#

#----- VARS LOCLAS -----#
my ($vboxXat,$entraEsc,$textIter,$textView,$thrFunciona,$thrPrepara,
	$bufferTV,$clientX,$serverX,$port,$tooltips,$Host);
	

#------ BOOLENANS ------#
my $creatServ = FALSE;
my $conectat = FALSE;
my $brut = FALSE;
	
#=======================#


#=======================================#
#====== PROGRAMA PRINCIPAL START =======#
#======                          =======#

crearXatVisible();

#=======                        ========#
#======= PROGRAMA PRINCIPAL END ========#
#=======================================#




#====== FUNCIONS DEL PROGRAMA START =======#

sub funcioXat {
		my $msg;
		if (uc($ARGV[0]) eq "CLIENT"){	
		}else{
			mostraMissatge("Rebent dades del xattttt - Server...\n");
			
		#while (1){
			print "llegir dades del Clienteeeeeeeeeeee!!\n";
			if ($msg = $serverX->llegirXat()){
				mostraMissatge("$Host: $msg\n");
			}
		#}
	}
}


sub crearXatVisible {
	
	my ($finestraPrin,$taulaXat,$scroll,$botoXat);
	
	$tooltips = Gtk2::Tooltips->new;
	
	# Crear finestra:
	$finestraPrin = Gtk2::Window->new('toplevel');
	if (uc($ARGV[0]) eq "CLIENT"){	
		$finestraPrin->set_title("Client Xat");
	}else{
		$finestraPrin->set_title("Servidor Xat");
	}
	$finestraPrin->signal_connect (delete_event => sub { Gtk2->main_quit });

	$vboxXat = Gtk2::VBox->new(FALSE,2);

	# GTK2::Table->($fila,$columna,$homogeni);
	$taulaXat = Gtk2::Table->new (2, 2, FALSE);

	$entraEsc = Gtk2::Entry->new();		#Text per escriure

	$scroll = Gtk2::ScrolledWindow->new (undef, undef);
	$scroll->set_shadow_type ('etched-out');
	$scroll->set_policy ('automatic', 'automatic');
	$scroll->set_size_request (450, 400);

	$textView = Gtk2::TextView->new();
	$bufferTV = $textView->get_buffer();
	$textView->set_editable (FALSE);
	$textView->set_cursor_visible (FALSE);

	$scroll->add($textView);

	$taulaXat->attach_defaults ($scroll, 0, 2, 0, 1);

	$botoXat = Gtk2::Button->new ("Envia!");

	$botoXat->signal_connect('button_release_event' => \&llegirText );
    
    my $hbboxXat = Gtk2::HButtonBox->new;    
    $hbboxXat->set_layout('spread');
    $hbboxXat->set_spacing(2);

	$tooltips->set_tip($entraEsc, 'Escriu el teu missatge');
	$tooltips->set_tip($botoXat, 'Envia el missatge');
		
    $hbboxXat->add($entraEsc);
    $hbboxXat->add($botoXat);
    
	$taulaXat->attach_defaults ($hbboxXat, 0, 2, 1, 2);

	$vboxXat->pack_start($taulaXat,TRUE,FALSE,4);	
	$vboxXat->pack_start(Gtk2::HSeparator->new(),FALSE,FALSE,4);
	
	afegirBotons();
	
	$finestraPrin->add($vboxXat);
	
	tancaFinestraIndividual($finestraPrin);
}

sub llegirText {
	
	my $text = $entraEsc->get_text();
		
	if( $entraEsc->get_text() ne "" || $conectat == TRUE){
		
		#Insert some text into the buffer
		mostraMissatge("Tu: $text \n");
		if (uc($ARGV[0]) eq "CLIENT"){	
			$clientX->escriureXat("$text\n");
		}		
	}else{
		#Insert some text into the buffer
		netejaBuf();
		mostraMissatge("No t'has conectat en cap servidor!!\n");
		$brut = TRUE;
	}
	$entraEsc->set_text("");
	
}

sub afegirBotons{
	
	my ($taulaBoto,$botoConn,	$botoDesconn);
	#create table to pack the labels that will demo how mnemonic text work
	# GTK2::Table->($fila,$columna,$homogeni);

	$taulaBoto = Gtk2::Table->new (1, 2, FALSE);
	#$table->attach_defaults ($widget, $pos_columna_esquerra, $pos_columna_dreta, $pos_fila_top, $pos_fila_bottom)
	
	if (uc($ARGV[0]) eq "CLIENT"){	
		$botoConn 		= Gtk2::Button->new('Connectar...');
		$botoDesconn 	= Gtk2::Button->new('Desconnecta i surt');
		$tooltips->set_tip($botoConn, 'Connecta amb el Servidor');
		$tooltips->set_tip($botoDesconn, 'Desconnecta del Servidor');
		
		$botoConn->signal_connect('clicked' => \&buscaServ );
		$botoDesconn->signal_connect('clicked' => \&apagaServ );
		
	}else{
		$botoConn 		= Gtk2::Button->new('Engegar Server');
		$botoDesconn 	= Gtk2::Button->new('Apagar Server');
		$tooltips->set_tip($botoConn, 'Executa el Servidor');
		$tooltips->set_tip($botoDesconn, "Apagar l'execucio i surt");
		
		$botoConn->signal_connect('clicked' => \&engegaServ );
		$botoDesconn->signal_connect('clicked' => \&apagaServ );
	}	
    
    $tooltips->enable;
    
    my $hbbox = Gtk2::HButtonBox->new;    
    $hbbox->set_layout('spread');
    $hbbox->set_spacing(3);

    $hbbox->add($botoConn);
    $hbbox->add($botoDesconn);

	
	$vboxXat->pack_end($hbbox,FALSE,FALSE,1);
}

sub msgErr1{
	netejaBuf();
	mostraMissatge("*********************\n");
	mostraMissatge("*********************\n");
	mostraMissatge("**      ERROR      **\n");
	mostraMissatge("*********************\n");
	mostraMissatge("*********************\n\n");
	mostraMissatge("Hi ha hagut algun error en el tancament del Servidor...\n");
}

sub apagaServ{
	my $text;
	if ($creatServ == TRUE){
		if (uc($ARGV[0]) eq "CLIENT"){	
			if ($clientX->tancarConnexioServidor()){
				netejaBuf();
				mostraMissatge("Servidor apagat correctament\n");
			}else{
				msgErr1();
			}
		}else{
			if ($serverX->tancarServer()){
				netejaBuf();
				mostraMissatge("Servidor apagat correctament\n");
			}else{
				msgErr1();
			}
		}
		$creatServ = FALSE;
	}else{
		
		if (uc($ARGV[0]) eq "CLIENT"){	
			$text = "No estas conectat a cap servidor!";
		}else{
			$text = "No tens cap servidor en execucio!";
		}
		
		my $dialog = 
		Gtk2::MessageDialog->new(undef,
                                [qw/modal destroy-with-parent/],
                                'error',
                                'ok',
                                $text);
		my $resposta = $dialog->run();
		if ($resposta eq 'ok') {
			$dialog->destroy;
		}
	}
}

sub engegaServ{
	my ($inCon,$labCon,$taulaCon,$dialog,$resposta);
	
	$taulaCon = Gtk2::Table->new (2, 2, FALSE);

	$inCon = Gtk2::Entry->new();		#Text per escriure
	$taulaCon->attach_defaults ($inCon, 1, 2, 0, 1);
	
	$labCon = Gtk2::Label->new("Port del Server: ");	#Text per escriure
	$taulaCon->attach_defaults ($labCon, 0, 1, 0, 1);

	$dialog = Gtk2::Dialog->new('Crea Server',
				undef,
				[qw/modal destroy-with-parent/],
				'gtk-ok'     => 'accept',
                'gtk-cancel' => 'reject'
                );
                
	$dialog->signal_connect('delete-event'=> sub {Gtk2->main_quit()});
				
	$dialog->set_position('center-always');
	
	$dialog->vbox->pack_start($taulaCon,FALSE,FALSE,4);
	
	$dialog->show_all();
	
	$resposta = $dialog->run();
	
	if ($resposta eq 'accept') {
		$port = $inCon->get_text();
		
		$serverX = serverX->new();
		$creatServ = TRUE;
		
		mostraMissatge($serverX->presentacio());
		mostraMissatge("\n\nConexio preparada al port: $port...");
		mostraMissatge("\nEsperant clients...\n");
		
		$brut = TRUE;
		
		$dialog->destroy();
		
		$thrPrepara = threads->create(\&preparaServ);

	}else{
		$dialog->destroy();
	}
}

sub preparaServ{
	
	my ($host,$adrIP);
	print "S'esta engegant el servidor...";
	
	($host,$adrIP)= $serverX->engega($port);
	
	$Host = $host;
	
	print "Host del client: $host, \@IP del client: $adrIP\n";
	#netejaBuf();
	mostraMissatge("S'ha connectat el host: $host, amb \@IP: $adrIP\n");
	$conectat = TRUE;		
	$brut = TRUE;
	
	$thrFunciona = threads->create(\&funcioXat);
}

sub mostraMissatge{
	my $missatge = shift;
	$textIter = $bufferTV->get_end_iter();
	$bufferTV->insert($textIter, $missatge);
	$textView->set_buffer($bufferTV);
}

sub netejaBuf{
	if ($brut == TRUE){
		$bufferTV->delete($bufferTV->get_start_iter,$textIter);
		$brut = FALSE;
	}
}

sub buscaServ {
	
	my ($inCon,$labCon,$labServ,$taulaCon,$dialog,$resposta);
	
	$taulaCon = Gtk2::Table->new (4, 2, FALSE);

	$inCon = Gtk2::Entry->new();		#Text per escriure
	$taulaCon->attach_defaults ($inCon, 1, 2, 0, 1);
	$inCon->signal_connect ('changed' => sub {
			my $text = $inCon->get_text();
			$dialog->set_response_sensitive ('accept', $text !~ m/^\s*$/);
		}
	);
	
	$labCon = Gtk2::Label->new("Servidor: ");	#Text per escriure
	$taulaCon->attach_defaults ($labCon, 0, 1, 0, 1);
	
	$labServ = Gtk2::Label->new("\n\n\n");			#Text per escriure
	$taulaCon->attach_defaults ($labServ, 0, 2, 1, 4);

	$dialog = Gtk2::Dialog->new('Connecta al servidor',
				undef,
				[qw/modal destroy-with-parent/],
				'gtk-ok'     => 'accept',
                'gtk-cancel' => 'reject'
                );
                
	$dialog->signal_connect('delete-event'=> sub {Gtk2->main_quit()});
                
	$dialog->set_response_sensitive ('accept', FALSE);
	$dialog->set_response_sensitive ('reject', TRUE);
				
	$dialog->set_position('center-always');
	
	$dialog->vbox->pack_start($taulaCon,FALSE,FALSE,4);
	
	$dialog->show_all();
	
	$resposta = $dialog->run();
	
	if ($resposta eq 'accept') {
		my $text = $inCon->get_text();
		my ($adrIP,$port);
		
		$conectat = TRUE;
		$creatServ = TRUE;
		netejaBuf();
		
		($adrIP,$port) = split(":", $text);
		
		$clientX = clientX->new();
		
		$labServ->set_text($clientX->engega($adrIP,$port));
		$dialog->destroy();		
	}else{
		$dialog->destroy();
	}
}

sub tancaFinestraIndividual {
	my $widget = shift;	
	$widget->show_all();
	Gtk2->main();
	$thrPrepara->join();
	#threads->exit();
	0;
}

#======= FUNCIONS DEL PROGRAMA END ========#
